Lua_CountInputWindow = class("Lua_CountInputWindow", Lua_Window);
function Lua_CountInputWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CountInputWindow";
	self.showClose = false;
	self.isClickClose = true;
	self.blackAlpha = 1 / 255;
	self.layer = 4500;
end

function Lua_CountInputWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.downMenuBg = UICreate.createUIAtlasImage(self.content, "common_atlas_2", "ui_common_tips_bg", 0, 0, 358, 263);

	local arr = Array();
	arr:add(1);
	arr:add(2);
	arr:add(3);
	arr:add("C");
	arr:add(4);
	arr:add(5);
	arr:add(6);
	arr:add(7);
	arr:add(8);
	arr:add(9);
	arr:add(0);
	arr:add("OK");

	self.count_DragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 296, 216));
	self.count_DragList:setLocation(2, -4, 0);
	self.count_DragList:setListCell(Lua_NumberItem, 72, 74, 4);
	self.count_DragList:setLuaArrayData(arr, true);

	self:addLuaEvent("ON_COUNTCELL_CLICK", self, self.onCountCellClick);
end

function Lua_CountInputWindow:showWin(param)
	self:superCall("showWin", param);

	if param ~= nil then
		self.owner = param.callBackOwner;
		self.callBack = param.callBack;
		-- self.content.transform.localPosition = Vector3(param.pox, param.poy);
		LuaUtil.setObjPos(self.content, param.pox, param.poy, 0);
	end
end

function Lua_CountInputWindow:onCountCellClick(data)
    if data.state == 2 then -- 关闭
        self:hide();
    else
        if self.callBack ~= nil and self.owner ~= nil then
            self.callBack(self.owner, data);
        elseif self.owner == nil and self.callBack ~= nil then
            self.callBack(data);
        end
    end
end

function Lua_CountInputWindow:hide()
    -- 回调完成
    local data = {state = 2};
    if self.callBack ~= nil and self.owner ~= nil then
        self.callBack(self.owner, data);
    elseif self.owner == nil and self.callBack ~= nil then
        self.callBack(data);
    end

    self:superCall("hide");
end

function Lua_CountInputWindow:dispose()
    if self.count_DragList ~= nil then
        self.count_DragList:dispose();
        self.count_DragList = nil;
    end
    self.owner = nil;
    self.callBack = nil;

    self:superCall("dispose");
end





--------------------------------------------------





Lua_NumberItem = class("Lua_NumberItem", Lua_ListCell);
function Lua_NumberItem:ctor(p)
	self:superCall("ctor", p, "NumberItem_skin");
	self.state = 1;
end

function Lua_NumberItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_NumberItem:setData(data)
	self._data = data

	self.numberLbl.text = data;
	if data == "C" then
		self.numberBg:setAltas("common_atlas_1", "ui_common_keyboard_03");
	elseif data == "OK" then
		self.numberBg:setAltas("common_atlas_1", "ui_common_keyboard_02");
	end
end

function Lua_NumberItem:onPlayerSoundClick(go)
	local state;
	local num;
	if self.numberLbl.text == "C" then
		state = 0;
		num = 1;
	elseif self.numberLbl.text == "OK" then
		state = 2;
		num = self._data;
	else
		state = 1;
		num = self._data;
	end
	Lua_MsgUtil.callFunc("ON_COUNTCELL_CLICK", {num = num, state = state});
end

function Lua_NumberItem:dispose(go)
    self:superCall("dispose");
end