Lua_ShopWindow = class("Lua_ShopWindow", Lua_FullSizeWindow)
function Lua_ShopWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ShopWindow";
	self.skinName = "Shopping_skin";
	self.showMarketMoney = 0;
end

function Lua_ShopWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.buyCount = 1;
	self.isFirst = true;
	self.numArr = Array();

	self:setShowTitle("titleName_altas_1", "shangcheng");

	self.shop_DragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 568, 554));
	self.shop_DragList:setLocation(-48, -27, 0);
	self.shop_DragList:setListCell(Lua_ShopItem, 116, 284, 2);

	self.desDragContainer = Lua_DragContainer.new(self.content, 1, Vector4(160, -47, 320, 94));
	self.desDragContainer:setLocation(259, 207, 0);
	self.desDragContainer = Lua_DesInfoPanel.new(self.desDragContainer);

	local shopConfig = getConfig({"shopName"});
	self.btnNames = Array();
	for k, v in pairs(shopConfig) do
		if v.shop_type == Lua_MoneyData.JEWEL then
			if DataCenter.roleData:checkGameSwich("diamond") ~= 0 then
				self.btnNames:add({id = k, name = v.name, shop_sort = v.shop_sort, moneyID = v.shop_type});
			end
		else
			self.btnNames:add({id = k, name = v.name, shop_sort = v.shop_sort, moneyID = v.shop_type});
		end
	end
	self.btnNames:sort("shop_sort", false);

	self.shopBtns = Lua_ButtonList.new(self.content, self.btnNames, 74, self, self.onButtonListClick,
		"ui_common_btn_p2", "ui_common_btn_p1", Vector4(0, 0, 212, 65), Vector4(0, 0, 212, 65),
		Lua_ColorDefine.transColor("D2D8DC"), Lua_ColorDefine.transColor("FFFFFF"), Vector4(28, 28, 212, 66), 1, "common_atlas_1", Vector3(-2, 2, 0));
	self.shopBtns:setDepth(5);
	self.shopBtns:setLocation(-500, 228, 0);
	self.shopBtns:setSelected(1, true);

	self.countBg:addClickFuntion(self, self.onCountBgClick);
	self.minusIcon:addClickFuntion(self, self.onMinusIconClick);
	self.plusIcon:addClickFuntion(self, self.onPlusIconClick);
	self.plusTenIcon:addClickFuntion(self, self.onPlusTenIconClick);
	self.buyBtn:addClickFuntion(self, self.onBuyButtonClick);

	self:addLuaEvent("ON_CELL_CLICK", self, self.onCellClick);
	self:addLuaEvent("SHOP_BUY", self, self.onUpdateDragList);
	self:addLuaEvent("UPDATE_PANELINFO", self, self.onUpdateInfo);
end

function Lua_ShopWindow:showWin(param)
	self:superCall("showWin", param);

	local toindex;
	if type(param) == "number" then
		toindex = param;
	elseif type(param) == "table" and param.openIdx ~= nil then
		toindex = param.openIdx;
	end
	
	if toindex ~= 1 and toindex ~= nil then
		self.shopBtns:setSelected(toindex, true);
	end
end

function Lua_ShopWindow:onCountBgClick()
	if self.data == nil then
		return;
	end
	Lua_WindowUtil.openWin("Lua_CountInputWindow", WinParam.ACTION_AUTO, {callBackOwner = self, pox = 425, poy = 10, callBack = self.onCountInputCallBack});
end

function Lua_ShopWindow:onMinusIconClick()
	if self.data == nil then
		return;
	end

	self.curItemID = self.data.id;
	if self.buyCount <= 1 then
		self.buyCount = 1;
	else
		self.buyCount = self.buyCount - 1;
	end
	self:onShowInfo();
end

function Lua_ShopWindow:onPlusIconClick()
	if self.data == nil then
		return;
	end

	self.curItemID = self.data.id;
	if self.data.maxCount ~= 0 then
		if self.buyCount < self.data.leftCount then
			self.buyCount = self.buyCount + 1;
		end
	else
		self.buyCount = self.buyCount + 1;
	end
	self:checkRange(self.buyCount)
	self:onShowInfo();
end

function Lua_ShopWindow:onPlusTenIconClick()
	if self.data == nil then
		return;
	end
	self.curItemID = self.data.id;
	self:checkRange(999);
	self:onShowInfo();
end

function Lua_ShopWindow:onBuyButtonClick()
	if self.data == nil then
		return;
	end

	if self.data._moneyType == Lua_MoneyData.GOLD then
		DataCenter.moneyData:showReconfigPanel(self._totalPrice, self, self._doBuyItem);
	else
		self:_doBuyItem();
	end
end

function Lua_ShopWindow:_doBuyItem()
	self.curItemID = self.data.id
	if DataCenter.moneyData:getMoney(self.data._moneyType) < self._totalPrice then
		if self.data._moneyType == Lua_MoneyData.GOLD then
			Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, des = LanUtil.getValue(110818), type = 1, subFun = self.onSubCallback});
			return;
		end
	end

	if DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getLeftSize() <= 0 then
		OperateAlert.show(LanUtil.getValue(121212));
		return;
	end

	if self.data.isCharmKing then
		local cmd = ProtoPublic_pb.Proto10102085();
		cmd.item_id = self.data.id;
		cmd.item_num = 1;
		sendMsg(10102085, cmd);
	else
		Lua_ProxyManager.getProxy("Lua_ShopProxy"):sBuyMsg(self.shopType, self.data.id, self.buyCount);
	end
end

function Lua_ShopWindow:onSubCallback()
	Lua_WindowUtil.openWin("Lua_ChongzhiWindow");
end

function Lua_ShopWindow:onButtonListClick(val)
	if self.isShowItem then
		if self.showData ~= nil and type(self.showData) == "table" and self.showData.itemID ~= nil and val == self.showData.openIdx then
			self.showData.itemID = nil;
		end
	end

	self.curPanelIndex = val;
	self.isFirst = true;

	self.moneyID = self.btnNames[val].moneyID;
	
	self.shopType = self.btnNames[val].id;
	Lua_ProxyManager.getProxy("Lua_ShopProxy"):sInitMsg(self.shopType);
end

function Lua_ShopWindow:onUpdateInfo()
	self.Arr = DataCenter.shopData.itemArr;
	if self.Arr ~= nil and self.Arr:getSize() ~= 0 then
		if self.data ~= nil then
			for i = 1, self.Arr:getSize() do
				if self.data.id == self.Arr[i].id then
					self.Arr[i].selected = true
					self.data = self.Arr[i]
				else
					self.Arr[i].selected = false
				end
			end
		end

		local firstTimeSelected = 1;
		if self.isFirst and self.showData ~= nil and type(self.showData) == "table" and self.showData.itemID ~= nil and self.showData.openIdx == self.curPanelIndex then
			local itemID = self:checkItemType(self.showData.itemID);
			for i = 1, self.Arr:getSize() do
				if itemID == self.Arr[i].id then
					firstTimeSelected = i;
					self.isShowItem = true;

					self.Arr[i].isShowEffectInFirst = self.showData.isShowEffectInFirst;
				else
					self.Arr[i].isShowEffectInFirst = false;
				end
			end
		end

		self.shop_DragList:setLuaArrayData(self.Arr, false);
		if self.Arr:getSize() > 0 and self.isFirst then
			self.shop_DragList:moveToIndex(math.floor((firstTimeSelected + 1) / 2), true);
			self.shop_DragList:setSelected(firstTimeSelected);
		end
	end

	if self.isFirst == false then
		self:onShowInfo();
	end
end

function Lua_ShopWindow:checkItemType(itemID)
	local subType = Lua_ToolVo.getSubType(itemID);

	local id;
	if subType == Lua_PackTypeDefine.WING_ITEM then -- 神翼区分职业
		local a = string.sub(itemID, 1, 2); -- 第1和第2个字符串
		local b = string.sub(itemID, 4, -1); -- -1是最后一个字符串
		id = tonumber(a..DataCenter.roleData.career..b);
	else
		id = itemID;
	end
	return id;
end

function Lua_ShopWindow:onCellDispose()
	if self.curItemID ~= self.data.id then
		self.buyCount = 1;
		self.numArr:clear();
	end
end

function Lua_ShopWindow:onCellClick(data)
	self.data = data;
	if self.data == nil then
		return;
	end
	self:onShowInfo();
end

function Lua_ShopWindow:onShowInfo()
	if self.data == nil then
		return;
	end

	if self.moneyID ~= 0 then
		self:showMoney1(true, self.moneyID);
	else
		self:showMoney1(false, nil);
	end

	self:onCellDispose();
	-- self.moneyIcon:setAltas(self.data.getMoneyIconAtlas, tostring(self.data.moneyType));
	self.moneyIcon2:setAltas(self.data.getMoneyIconAtlas, tostring(self.data.moneyType));
	self.moneyIcon3:setAltas(self.data.getMoneyIconAtlas, tostring(self.data.moneyType));

	if self.data.colorStr == Lua_ColorDefine.BLUE_STR then
		self.itemName.text = "[006cfe]" .. self.data.name;
	else
		self.itemName.text = self.data.colorName;
	end

	self.itemDes.text = ""
	self.desDragContainer:updateSubPos();
	self.desDragContainer:setText(self.data.des);

	-- if self.shopType == 1 then
		if self.data.maxCount ~= 0 then
			-- 限购
			if self.data.itemType == 0 then
				self.buyTimes.text = LanUtil.formateStr(LanUtil.getValue(121205), tostring(self.data.leftCount), tostring(self.data.maxCount));
			elseif self.data.itemType == 1 then
				self.buyTimes.text = LanUtil.formateStr(LanUtil.getValue(121216), tostring(self.data.leftCount), tostring(self.data.maxCount));
			else
				self.buyTimes.text = LanUtil.formateStr(LanUtil.getValue(121219), tostring(self.data.leftCount), tostring(self.data.maxCount));
			end
		else
			self.buyTimes.text = LanUtil.getValue(121217);
		end
	-- else
	-- end
	self.limitLbl.text = LanUtil.formateStr(LanUtil.getValue(121206), tostring(self.data.vipLimit));

	-- if self.data.prePrice ~= 0 then
	-- 	local moneyStr = tostring(self.data.prePrice);
	-- 	if getLanType() == 1 then
	-- 		moneyStr = Lua_ChatUtil.FACE_SPACE..moneyStr;
	-- 	end
	-- 	self.prePrice.text = LanUtil.formateStr(LanUtil.getValue(121207), moneyStr);
	-- 	self.moneyIcon.mainContent:SetActive(true);
	-- 	self.line.mainContent:SetActive(true);
	-- else
	-- 	self.prePrice.text = "";
	-- 	self.moneyIcon.mainContent:SetActive(false);
	-- 	self.line.mainContent:SetActive(false);
	-- end

	self.curPrice.text = self.data.curPrice;
	self:onCountInputCallBack({num = self.buyCount, state = 3});
end

function Lua_ShopWindow:onCountInputCallBack(data)
	if data.state == 3 then
		self.buyCount = data.num
	elseif data.state == 1 then
		self.count.text = ""
		self.numArr:add(data.num);
		for i = 1, self.numArr:getSize() do
			self.count.text = self.count.text .. self.numArr[i]
		end
		self.buyCount = tonumber(self.count.text)
	elseif data.state == 0 then
		self.numArr:clear();
		self.buyCount = 1
	end

	if data.state == 2 then
		self.numArr:clear();
	end
	self:checkRange(self.buyCount)
	self.count.text = self.buyCount

	self._totalPrice = self.buyCount * self.data.curPrice;
	local mstr = tostring(self._totalPrice);
	if DataCenter.moneyData:getMoney(self.data._moneyType) < self._totalPrice then
		self.totalPriceLabel.text = "[FF1616]總價：";
		self.totalPrice.text = "[FF1616]" ..mstr;
	else
		self.totalPriceLabel.text = "[00E125]總價：";
		self.totalPrice.text = "[00E125]" ..mstr;
	end
end

function Lua_ShopWindow:checkRange(num)
	if num >= self.data.leftCount and self.data.maxCount ~= 0 then
		if self.data.leftCount == 0 then
			self.buyCount = 1
		else
			self.buyCount = self.data.leftCount
		end
	else
		if self.buyCount >= 999 then
			self.buyCount = 999
		elseif self.buyCount < 1 then
			self.buyCount = 1
		else
			self.buyCount = num
		end
	end
end

function Lua_ShopWindow:onUpdateDragList()
	self.isFirst = false;
	Lua_ProxyManager.getProxy("Lua_ShopProxy"):sInitMsg(self.shopType);
end

function Lua_ShopWindow:dispose()
	if self.shop_DragList ~= nil then
		self.shop_DragList:dispose();
		self.shop_DragList = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_DesInfoPanel = class("Lua_DesInfoPanel", Lua_DragContainerItem);
function Lua_DesInfoPanel:ctor(dragContainer)
	self:superCall("ctor", dragContainer.sub);

	dragContainer:addSubContainer(self, true);
	self.dragContainer = dragContainer;
end

function Lua_DesInfoPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.itemDes = UICreate.createLabel(self.content, "", 0, 0, 310, 30, 22);
	self.itemDes:setDepth(3);
	self.itemDes.pivot = UIWidget.Pivot.TopLeft;
	self.itemDes.overflowMethod = UILabel.Overflow.ResizeHeight;
	self.itemDes.spacingY = 6;
end

function Lua_DesInfoPanel:setText(data)
	self.itemDes.text = "[85A8BE]" .. data .. "[-]";
	self.dragContainer:updateChildPos();
	self.dragContainer.canDrag = false;
	self.dragContainer.canDrag = self:getHeight() > 84;
end

function Lua_DesInfoPanel:updateSubPos()
	self.dragContainer:updateSubPos(0, 0, 0);
end

function Lua_DesInfoPanel:getHeight()
	return self.itemDes.height;
end





--------------------------------------------------





Lua_ShopItem = class("Lua_ShopItem", Lua_ListCell);
function Lua_ShopItem:ctor(p)
    self:superCall("ctor", p, "ShopItem_skin");
end

function Lua_ShopItem:buildShowItem()
    self:superCall("buildShowItem");

    self.itemImg = Lua_ToolImage.new(self.content);
    self.itemImg:setDepth(5);
    self.itemImg:setLocation(-86, 6.5, 0);

    self.effect = UICreate.createUIEffect(self.itemBg.mainContent, nil, nil, 0, 0);
    self.effect:SetRenderQueue(self.nameLbl, 5, 2, false);
    self.effect:setEnable(false);
end

function Lua_ShopItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	if data.subType == 117 then
		data.wingColor= 0;
	end

	self.itemImg.data = data
	if data.one_buy_num ~= nil and data.one_buy_num ~= 0 then
		self.itemImg:showNum(data.one_buy_num);
		if data.maxCount ~= 0 then
			self.itemImg:showNum2(data.leftCount, data.maxCount, 2);
		end
	end

	if self.itemImg.data.colorStr == Lua_ColorDefine.BLUE_STR then
		self.nameLbl.text = "[006cfe]" .. self.itemImg.data.name;
	else
		self.nameLbl.text = self.itemImg.data.colorName;
	end

	self.effect:setUrl(nil, nil)
	if data.isShowEffectInFirst then
		-- self.effect:setUrl("/effects/scsEffects/gui_shangchengwupinkuang", "gui_shangchengwupinkuang");
		-- self.effect.mainContent:SetActive(true);
	else
		if data.item_effect ~= nil then
			self.effect:setUrl("/effects/scsEffects/" .. data.item_effect, data.item_effect)
			self.effect.mainContent:SetActive(true);
		else
			self.effect:setUrl(nil, nil)
			self.effect.mainContent:SetActive(false);
		end
	end

	if data.maxCount ~= 0 then
		if data.leftCount == 0 then
			if data.limit_item_effect ~= nil and data.limit_item_effect == 1 then
				self.effect:setUrl("/effects/scsEffects/" .. data.item_effect, data.item_effect)
				self.effect.mainContent:SetActive(true);
			else
				self.effect:setUrl(nil, nil)
				self.effect.mainContent:SetActive(false);
			end
		end
	end

	-- if data.item_des ~= nil then
	-- 	if data.limt_show ~= nil and data.limt_show == 1 then
	-- 		if data.vip == true then
	-- 			self.prePrice.text = "[192e41]" .. data.item_des;
	-- 		else
	-- 			self.prePrice.text = "[f42a2a]" .. data.item_des;
	-- 		end
	-- 	else
	-- 		self.prePrice.text = "[192e41]" .. data.item_des;
	-- 	end
	-- 	self.moneyIcon.mainContent:SetActive(false);
	-- 	self.line.mainContent:SetActive(false);
	-- else
	-- 	if data.prePrice ~= 0 then
	-- 		local moneyStr = tostring(self.data.prePrice);
	-- 		if getLanType() == 1 then
	-- 			moneyStr = Lua_ChatUtil.FACE_SPACE..FACE_SPACE..moneyStr;
	-- 		end
	-- 		self.prePrice.text = LanUtil.formateStr(LanUtil.getValue(121207), moneyStr);
	-- 		self.moneyIcon.mainContent:SetActive(true);
	-- 		self.line.mainContent:SetActive(true);
	-- 	else
	-- 		self.prePrice.text = "";
	-- 		self.moneyIcon.mainContent:SetActive(false);
	-- 		self.line.mainContent:SetActive(false);
	-- 	end
	-- end

	-- if data.icon_des ~= nil then
	-- 	self.zkObj.gameObject:SetActive(true);
	-- 	if getLanType() == 1 then
	-- 		self.priceLbl.fontSize = 13;
	-- 		self.priceLbl:SetDimensions(30, 50);
	-- 	end
	-- 	self.priceLbl.text = data.icon_des
	-- else
	-- 	self.zkObj.gameObject:SetActive(false);
	-- 	self.priceLbl.text = "";
	-- end

	-- self.moneyIcon:setAltas(data.getMoneyIconAtlas, data.moneyType);
	self.curPrice.text = data.curPrice;

	self.moneyIcon2:setAltas(data.getMoneyIconAtlas, data.moneyType);
	self.itemBg:setAltas("common_atlas_1", data.selected and "ui_common_widget_p2" or "ui_common_widget_p1");
end

-- function Lua_ShopItem:onPlayerSoundClick()
-- 	Lua_MsgUtil.callFunc("ON_CELL_CLICK", self._data);
-- end

function Lua_ShopItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);

	if val then
		self.itemBg:setAltas("common_atlas_1", "ui_common_widget_p2");
		self.selectOutline:setEnable(true);

		Lua_MsgUtil.callFunc("ON_CELL_CLICK", self._data);
	else
		self.itemBg:setAltas("common_atlas_1", "ui_common_widget_p1");
		self.selectOutline:setEnable(false);
	end
end

function Lua_ShopItem:dispose()
	if self.itemImg ~= nil then
		self.itemImg:dispose();
		self.itemImg = nil;
	end
	if self.effect ~= nil then
		self.effect:dispose();
		self.effect = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end